#pragma once
#include <exception>
#include <string>

class File_not_found : public std::exception {
	std::string err;
public:
	File_not_found() {
		err.assign("Error : unable to open file");
	}
	explicit File_not_found(const std::string& file) {
		err.assign("Error: Unable to open " + file + " file");
	}
	const char* what() const noexcept override {
		return err.c_str();
	}
};

class Wrong_file_format : public std::exception {
	std::string err;
public:
	Wrong_file_format() {
		err.assign("Error : inappropriate file format");
	}
	explicit Wrong_file_format(const std::string& file_format) {
		err.assign("Error : Format " + file_format + " is unsuitable");
	}
	const char* what() const noexcept override {
		return err.c_str();
	}
};
