#pragma once
#include <iostream>
#include <vector>
#include <set>
#include <list>
#include <array>

#include "Structure.h"

using std::cin;
using std::cout;
using std::endl;
using std::string;

class MeshLoader {
protected:
	std::vector<Node> nodes;
	std::vector<FiniteElement> finiteElements;
	std::vector <BoundaryFiniteElement> boundaryFiniteElements;
public:
	virtual void loadMesh(const string&) = 0;
	virtual ~MeshLoader() = default;

	std::vector<Node>& GetNodes();
	std::vector<FiniteElement>& GetFE();
	std::vector<BoundaryFiniteElement>& GetBFE();
	std::vector<int> findFE(size_t, size_t, size_t);
	std::vector<FiniteElement> findEdge(size_t, size_t);
	std::vector<size_t> vertex_node_by_id(size_t);
	std::vector<std::set<size_t>> get_close_nodes();
	std::vector<Node> get_material_id(size_t);
	std::vector<BoundaryFiniteElement> get_BoundaryFinite_id(size_t);
	Node get_node(size_t);
	Node& get_node_by_id(size_t);

	void Print();
	void insert_node();
	
};
