﻿#include <iostream>
#include <string>
#include <fstream>
#include <algorithm>
#include <set>

#include "AneuMeshLoader.h"

int main() {
    const std::string name = "myfile";
    std::vector<size_t> node;
    MeshLoader* load = new AneuMeshLoader;
    std::vector<int> elem;
    std::vector<FiniteElement> FEelem;
    std::vector<std::vector<Node>> close;
    std::vector<BoundaryFiniteElement> surface;

    load->loadMesh(name);
    std::cout << "TEST" << std::endl;

    std::cout << "find finite element" << std::endl;
    elem = load->findFE(3, 2, 2);
    std::cout << elem << std::endl;
    elem.clear();

    std::cout << "findEdge" << std::endl;
    FEelem = load->findEdge(1, 2);
    for (const auto& x : FEelem)  
        std::cout << x << std::endl;
    FEelem.clear();

    std::cout << "get vertex node by id" << std::endl;
    node = load->vertex_node_by_id(1);
    std::cout << node << std::endl;
    node.clear();

    std::cout << "get boundary finite id" << std::endl;
    surface = load->get_BoundaryFinite_id(1);
    std::cout << surface << std::endl;
    surface.clear();

    std::cout << "Insert nodes" << std::endl;
    load->insert_node();
    load->Print();
    delete(load);
    return 0;
}
